;-------------------------------------------------------------------------
;				Command Interpreter
;-------------------------------------------------------------------------
;input: Y: input buffer
;output: addrxh, addrh, addrl: 20 bit hex value
;
exec_command:
#if defined(__ATmega128__)										;GL
	ldi 	zl, byte3( command_table * 2 - 3 )								
    out 	rampz, zl													
#endif
	ldi		zl, low( command_table * 2 - 3 )
	ldi		zh, high( command_table * 2 - 3 )
	sbrs	flags, f_enable
	ldi		zl, low( command_enable * 2 - 3 )
	sbrs	flags, f_enable
	ldi		zh, high( command_enable * 2 - 3 )
	mov		a1, yl			;save command start
_coi1:	
	adiw	zl, 3
	andi	zl, 0xFE		;adjust to next word
	mov		yl, a1
	clt
	rjmp	_coi3

_coi2:	
	ld		a0, y
	inc		yl
	eor		a0, r0
	andi	a0, 0x5F		;ignore case
	breq	_coi3
	set				;not matching

_coi3:	
#if defined(__ATmega128__)										;GL
	elpm	r0, z+
#else
	lpm		r0, z+
#endif

	tst		r0
	brne	_coi2
	brts	_coi1			;test next command

	clr		addrl
	clr		addrh
	clr		addrxh
_coi4:	
	ld		a0, y
	inc		yl
	tst		a0
	breq	_coi6

	rcall	ascii_hex		;read hex value after command
	rjmp	_coi4

_coi6:	
#if defined(__ATmega128__)										;GL
    in 		a0, rampz
	lsr 	a0
	out 	rampz, a0											
	ror 	zh
	ror 	zl
#else
	lsr		zh					;byte to word address
	ror		zl
#endif
	ijmp
;-------------------------------------------------------------------------
